diff --git a/platform/linux-generic/include/odp_queue_subsystem.h b/include/odp/subsystem/spec/queue_subsystem.h
similarity index 100%
rename from platform/linux-generic/include/odp_queue_subsystem.h
rename to include/odp/subsystem/spec/queue_subsystem.h
diff --git a/include/odp_mf.h b/include/odp_mf.h
index 9b83e8680..ce5ff5b65 100644
--- a/include/odp_mf.h
+++ b/include/odp_mf.h
@@ -21,6 +21,7 @@ extern C {
 #include <odp/mf/spec/module.h>
 #include <odp/subsystem/spec/buffer_subsystem.h>
 #include <odp/subsystem/spec/pool_subsystem.h>
+#include <odp/subsystem/spec/queue_subsystem.h>
 
 #ifdef __cplusplus
 }
diff --git a/platform/Makefile.inc b/platform/Makefile.inc
index bb928c83c..6965a0e4b 100644
--- a/platform/Makefile.inc
+++ b/platform/Makefile.inc
@@ -85,7 +85,8 @@ odpmfspecinclude_HEADERS = \
 odpsubsystemspecincludedir= $(includedir)/odp/subsytem/spec
 odpsubsystemspecinclude_HEADERS = \
 		  $(top_srcdir)/include/odp/subsystem/spec/buffer_subsystem.h \
-		  $(top_srcdir)/include/odp/subsystem/spec/pool_subsystem.h
+		  $(top_srcdir)/include/odp/subsystem/spec/pool_subsystem.h \
+		  $(top_srcdir)/include/odp/subsystem/spec/queue_subsystem.h
 
 odpapiabidefaultincludedir= $(includedir)/odp/arch/default/api/abi
 odpapiabidefaultinclude_HEADERS = \
diff --git a/platform/linux-dpdk/Makefile.am b/platform/linux-dpdk/Makefile.am
index cf3e822e9..3ac7df565 100644
--- a/platform/linux-dpdk/Makefile.am
+++ b/platform/linux-dpdk/Makefile.am
@@ -206,7 +206,6 @@ noinst_HEADERS = \
 		  ${srcdir}/include/odp_posix_extensions.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_queue_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_queue_if.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_queue_subsystem.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_ring_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_if.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_subsystem.h \
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index a871afae2..8172244b1 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -185,7 +185,6 @@ noinst_HEADERS = \
 		  ${srcdir}/include/odp_pktio_ops_tap.h \
 		  ${srcdir}/include/odp_pktio_ops_subsystem.h \
 		  ${srcdir}/include/odp_pkt_queue_internal.h \
-		  ${srcdir}/include/odp_queue_subsystem.h \
 		  ${srcdir}/include/odp_pool_internal.h \
 		  ${srcdir}/include/odp_posix_extensions.h \
 		  ${srcdir}/include/odp_queue_internal.h \
diff --git a/platform/linux-generic/queue/generic.c b/platform/linux-generic/queue/generic.c
index ab2b97048..3099fe158 100644
--- a/platform/linux-generic/queue/generic.c
+++ b/platform/linux-generic/queue/generic.c
@@ -9,7 +9,7 @@
 #include <odp/api/queue.h>
 #include <odp_queue_internal.h>
 #include <odp_queue_if.h>
-#include <odp_queue_subsystem.h>
+#include <odp/subsystem/spec/queue_subsystem.h>
 #include <odp/api/std_types.h>
 #include <odp/api/align.h>
 #include <odp/api/buffer.h>
diff --git a/platform/linux-generic/queue/scalable.c b/platform/linux-generic/queue/scalable.c
index 00cd8da65..ab592a130 100644
--- a/platform/linux-generic/queue/scalable.c
+++ b/platform/linux-generic/queue/scalable.c
@@ -23,7 +23,7 @@
 #include <odp_packet_io_internal.h>
 #include <odp_pool_internal.h>
 #include <odp_queue_scalable_internal.h>
-#include <odp_queue_subsystem.h>
+#include <odp/subsystem/spec/queue_subsystem.h>
 #include <odp_schedule_if.h>
 #include <_ishm_internal.h>
 #include <_ishmpool_internal.h>
diff --git a/platform/linux-generic/queue/subsystem.c b/platform/linux-generic/queue/subsystem.c
index 05e8edb8e..2fba9f374 100644
--- a/platform/linux-generic/queue/subsystem.c
+++ b/platform/linux-generic/queue/subsystem.c
@@ -11,7 +11,7 @@
 #include <odp/api/queue.h>
 #include <odp_internal.h>
 #include <odp_debug_internal.h>
-#include <odp_queue_subsystem.h>
+#include <odp/subsystem/spec/queue_subsystem.h>
 
 ODP_SUBSYSTEM_DEFINE(queue, "queue public APIs", QUEUE_SUBSYSTEM_VERSION);
 