diff --git a/platform/linux-generic/include/odp_schedule_subsystem.h b/include/odp/subsystem/spec/schedule_subsystem.h
similarity index 100%
rename from platform/linux-generic/include/odp_schedule_subsystem.h
rename to include/odp/subsystem/spec/schedule_subsystem.h
diff --git a/include/odp_mf.h b/include/odp_mf.h
index ce5ff5b65..a03040c23 100644
--- a/include/odp_mf.h
+++ b/include/odp_mf.h
@@ -22,6 +22,7 @@ extern C {
 #include <odp/subsystem/spec/buffer_subsystem.h>
 #include <odp/subsystem/spec/pool_subsystem.h>
 #include <odp/subsystem/spec/queue_subsystem.h>
+#include <odp/subsystem/spec/schedule_subsystem.h>
 
 #ifdef __cplusplus
 }
diff --git a/platform/Makefile.inc b/platform/Makefile.inc
index 6965a0e4b..da1fb52e3 100644
--- a/platform/Makefile.inc
+++ b/platform/Makefile.inc
@@ -86,7 +86,8 @@ odpsubsystemspecincludedir= $(includedir)/odp/subsytem/spec
 odpsubsystemspecinclude_HEADERS = \
 		  $(top_srcdir)/include/odp/subsystem/spec/buffer_subsystem.h \
 		  $(top_srcdir)/include/odp/subsystem/spec/pool_subsystem.h \
-		  $(top_srcdir)/include/odp/subsystem/spec/queue_subsystem.h
+		  $(top_srcdir)/include/odp/subsystem/spec/queue_subsystem.h \
+		  $(top_srcdir)/include/odp/subsystem/spec/schedule_subsystem.h
 
 odpapiabidefaultincludedir= $(includedir)/odp/arch/default/api/abi
 odpapiabidefaultinclude_HEADERS = \
diff --git a/platform/linux-dpdk/Makefile.am b/platform/linux-dpdk/Makefile.am
index 3ac7df565..96915e818 100644
--- a/platform/linux-dpdk/Makefile.am
+++ b/platform/linux-dpdk/Makefile.am
@@ -208,7 +208,6 @@ noinst_HEADERS = \
 		  ${top_srcdir}/platform/linux-generic/include/odp_queue_if.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_ring_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_if.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_subsystem.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_sorted_list_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_shm_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_time_internal.h \
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 8172244b1..027e54fd8 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -195,7 +195,6 @@ noinst_HEADERS = \
 		  ${srcdir}/include/odp_schedule_scalable.h \
 		  ${srcdir}/include/odp_schedule_scalable_config.h \
 		  ${srcdir}/include/odp_schedule_scalable_ordered.h \
-		  ${srcdir}/include/odp_schedule_subsystem.h \
 		  ${srcdir}/include/odp_sorted_list_internal.h \
 		  ${srcdir}/include/odp_shm_internal.h \
 		  ${srcdir}/include/odp_time_internal.h \
diff --git a/platform/linux-generic/schedule/generic.c b/platform/linux-generic/schedule/generic.c
index 73fef40cb..39bf2d4f5 100644
--- a/platform/linux-generic/schedule/generic.c
+++ b/platform/linux-generic/schedule/generic.c
@@ -25,7 +25,7 @@
 #include <odp/api/packet_io.h>
 #include <odp_ring_internal.h>
 #include <odp_timer_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <odp/subsystem/spec/schedule_subsystem.h>
 #include <odp_packet_io_internal.h>
 
 /* Should remove this dependency */
diff --git a/platform/linux-generic/schedule/iquery.c b/platform/linux-generic/schedule/iquery.c
index 5de229832..13f6ade26 100644
--- a/platform/linux-generic/schedule/iquery.c
+++ b/platform/linux-generic/schedule/iquery.c
@@ -25,7 +25,7 @@
 #include <odp/api/packet_io.h>
 #include <odp_config_internal.h>
 #include <odp_timer_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <odp/subsystem/spec/schedule_subsystem.h>
 #include <odp_packet_io_internal.h>
 
 /* Should remove this dependency */
diff --git a/platform/linux-generic/schedule/scalable.c b/platform/linux-generic/schedule/scalable.c
index d8f538202..0266bd1c4 100644
--- a/platform/linux-generic/schedule/scalable.c
+++ b/platform/linux-generic/schedule/scalable.c
@@ -29,7 +29,7 @@
 #include <odp_llqueue.h>
 #include <odp_queue_scalable_internal.h>
 #include <odp_schedule_if.h>
-#include <odp_schedule_subsystem.h>
+#include <odp/subsystem/spec/schedule_subsystem.h>
 #include <odp_bitset.h>
 #include <odp_packet_io_internal.h>
 
diff --git a/platform/linux-generic/schedule/sp.c b/platform/linux-generic/schedule/sp.c
index ea7b83422..b00b4f290 100644
--- a/platform/linux-generic/schedule/sp.c
+++ b/platform/linux-generic/schedule/sp.c
@@ -18,7 +18,7 @@
 #include <odp_config_internal.h>
 #include <odp_ring_internal.h>
 #include <odp_timer_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <odp/subsystem/spec/schedule_subsystem.h>
 #include <odp_packet_io_internal.h>
 #include <odp_queue_internal.h>
 
diff --git a/platform/linux-generic/schedule/subsystem.c b/platform/linux-generic/schedule/subsystem.c
index 99c6141c2..08e2aa752 100644
--- a/platform/linux-generic/schedule/subsystem.c
+++ b/platform/linux-generic/schedule/subsystem.c
@@ -14,7 +14,7 @@
 /* Internal header files */
 #include <odp_debug_internal.h>
 #include <odp_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <odp/subsystem/spec/schedule_subsystem.h>
 
 ODP_SUBSYSTEM_DEFINE(schedule, "schedule public APIs",
 		     SCHEDULE_SUBSYSTEM_VERSION);